/*!
	Document:      playground.js
	Date started:  11 May 2018
	By:            Matt Fozard
	Purpose:       Quru Image Server file details helpers
	Requires:      base.js
				   common_view.js
				   canvas_view.js
	               lassocrop.js (which requires MooTools)
	Copyright:     Quru Ltd (www.quru.com)
	Licence:

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Affero General Public License as published
	by the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Affero General Public License for more details.

	You should have received a copy of the GNU Affero General Public License
	along with this program.  If not, see http://www.gnu.org/licenses/

	Last Changed:  $Date$ $Rev$ by $Author$
	
	Notable modifications:
	Date       By    Details
	=========  ====  ============================================================
*/
"use strict";
var Playground={imageBaseURL:"",imageSpec:{},imageSpecOrig:{},ready:false};Playground._resourceSize=function(a){if(window.performance&&window.performance.getEntriesByType){var c=performance.getEntriesByType("resource");
for(var b=0;b<c.length;b++){if(c[b].name===a){return c[b].decodedBodySize||0;}}}return 0;};Playground._initStickyButtons=function(a,b){var d=document.querySelectorAll(a);
for(var c=0;c<d.length;c++){d[c].addEventListener("click",function(i){var f=this.getAttribute("sticky-group");
if(f){for(var g=0;g<d.length;g++){var h=d[g].getAttribute("sticky-group");if(h===f){QU.elSetClass(d[g],b,false);
}}QU.elSetClass(this,b,true);}});}};Playground._formatBytes=function(c){var b=["bytes","KB","MB","GB","TB","PB","EB","ZB","YB"],a=0;
while(c>=1024&&++a){c/=1024;}return(c.toFixed((c>=10||a<1)?0:1)+" "+b[a]);};Playground._getQS=function(a){var b=a.indexOf("?");
if(b!==-1){return a.substring(b+1);}return a;};Playground._cleanImageSpec=function(a){a.strip=false;delete a.attach;
delete a.tmp;return a;};Playground.selectImage=function(a){var c=a.indexOf("?");if(c!==-1){Playground.imageBaseURL=a.substring(0,c);
Playground.imageSpec=QU.QueryStringToObject(a.substring(c+1),false);Playground.imageSpec=Playground._cleanImageSpec(Playground.imageSpec);
Playground.imageSpecOrig=QU.clone(Playground.imageSpec);}else{Playground.imageSpec={};Playground.imageSpecOrig={};
}var b=QU.id("pg_selection");if(b){QU.elSetClass(b,"selected",true);QU.elSetClass(QU.id("pg_main"),"selected",true);
setTimeout(Playground.onImageSelectorAnimationComplete,Playground.getImageSelectorAnimationDuration()+50);
QU.elSetClass(QU.id("pg_reselect"),"hidden",false);}Playground.ready=true;QU.elRemove("preview_image_msg");
Playground.reset();};Playground.openImageSelector=function(){var a=QU.id("pg_selection");if(a){QU.elSetClass(a,"selected",false);
QU.elSetClass(QU.id("pg_main"),"selected",false);setTimeout(Playground.onImageSelectorAnimationComplete,Playground.getImageSelectorAnimationDuration()+50);
}};Playground.onImageSelectorAnimationComplete=function(){if(Playground.cropTool){Playground.cropTool.getRelativeOffset();
}};Playground.getImageSelectorAnimationDuration=function(){var c=QU.id("pg_selection");if(c){var a=QU.elGetStyles(c,["transition-duration"]);
var b=a?a["transition-duration"]:"";if(b&&b.substring(b.length-2)=="ms"){return parseFloat(b);}else{if(b&&b.substring(b.length-1)=="s"){return parseFloat(b)*1000;
}}}return 1000;};Playground.play=function(a){if(!Playground.ready){return;}QU.merge(Playground.imageSpec,a);
Playground.refreshPreviewImage();if((a.angle!==undefined)||(a.flip!==undefined)){Playground.refreshCropImage();
}};Playground.showPreviewImageSize=function(b){var a=QU.id("preview_image"),d=QU.id("preview_image_size"),c=Playground._resourceSize(a.src);
if(b&&c){d.innerText="(file size "+Playground._formatBytes(c)+")";}else{d.innerText="";}};Playground.refreshPreviewImage=function(){if(!Playground.ready){return;
}var a=QU.id("preview_image"),c=QU.id("wait_image"),b=Playground.imageBaseURL+"?"+QU.ObjectToQueryString(Playground.imageSpec);
QU.id("view_plain").href=b;QU.id("view_download").href=b+"&amp;attach=1";var d=QU.clone(Playground.imageSpec);
d.format="pdf";d.dpi=150;QU.id("view_pdf").href=Playground.imageBaseURL+"?"+QU.ObjectToQueryString(d);
if(Playground._getQS(b)!==Playground._getQS(a.src)){Playground.showPreviewImageSize(false);a.src=b;if(a.complete){Playground.onPreviewImageLoaded();
}else{QU.elSetClass(a,"loading",true);QU.elSetClass(c,"hidden",false);}}};Playground.onPreviewImageLoaded=function(){if(!Playground.ready){return;
}var a=QU.id("preview_image"),b=QU.id("wait_image");QU.elSetClass(a,"loading",false);QU.elSetClass(a,"hidden",false);
QU.elSetClass(b,"hidden",true);Playground.showPreviewImageSize(true);};Playground.refreshCropImage=function(){if(!Playground.ready){return;
}var e={src:Playground.imageSpec.src,width:200,height:200,autosizefit:1,strip:1,stats:0};var d=["format","colorspace","angle","flip"];
d.forEach(function(f){if(Playground.imageSpec[f]){e[f]=Playground.imageSpec[f];}});var c=document.querySelector(".crop_container"),a=QU.id("crop_image"),b=Playground.imageBaseURL+"?"+QU.ObjectToQueryString(e);
if(Playground._getQS(b)!==Playground._getQS(a.src)){QU.elSetClass(c,"loading",true);a.src=b;if(a.complete){Playground.onCropImageLoaded();
}}};Playground.onCropImageLoaded=function(){if(!Playground.ready){return;}var b=document.querySelector(".crop_container"),a=QU.id("crop_image");
QU.elSetClass(b,"loading",false);if(Playground.cropTool){Playground.cropTool.destroy();}Playground.cropTool=new Lasso.Crop(a,{ratio:false,preset:[0,0,a.width,a.height],min:[10,10],handleSize:10,opacity:0.6,color:"#000",border:"../static/images/crop.gif",onComplete:Playground.onCropComplete});
};Playground.onCropComplete=function(b){var a=QU.id("crop_image");if(!b||(!b.x&&!b.y&&!b.w&&!b.h)){Playground.cropTool.resetCoords();
Playground.cropTool.setDefault();b=Playground.cropTool.getRelativeCoords();}Playground.play({left:(b.x>0)?(b.x/a.width):0,top:(b.y>0)?(b.y/a.height):0,right:((b.x+b.w)<a.width)?((b.x+b.w)/a.width):1,bottom:((b.y+b.h)<a.height)?((b.y+b.h)/a.height):1});
};Playground.resetCrop=function(a){if(Playground.cropTool){Playground.cropTool.resetCoords();Playground.cropTool.setDefault();
if(a){Playground.play({left:0,top:0,right:1,bottom:1});}}};Playground.viewFullScreen=function(){if(!Playground.ready){return;
}canvas_view_init_image("preview_image");var b=QU.id("preview_image"),a=b._onclick;if(a){a();b.removeEventListener("click",a);
}};Playground.resetUI=function(){var a=document.querySelectorAll(".controls input");for(var b=0;b<a.length;
b++){a[b].checked=false;}var c=document.querySelectorAll(".controls button");for(var b=0;b<c.length;b++){QU.elSetClass(c[b],"active",QU.elHasClass(c[b],"default"));
}Playground.resetCrop(false);};Playground.reset=function(){if(!Playground.ready){return;}Playground.resetUI();
Playground.imageSpec=QU.clone(Playground.imageSpecOrig);QU.merge(Playground.imageSpec,{width:500,height:500,format:"jpg",quality:80,colorspace:"srgb"});
Playground.refreshPreviewImage();Playground.refreshCropImage();};Playground.init=function(){var a=document.querySelectorAll(".pg_selection img");
for(var c=0;c<a.length;c++){a[c].addEventListener("click",function(d){d.preventDefault();Playground.selectImage(this.src);
return false;});}var b=document.querySelector("#pg_reselect a");if(b){b.addEventListener("click",function(d){d.preventDefault();
Playground.openImageSelector();return false;});}QU.id("view_full").addEventListener("click",function(d){d.preventDefault();
Playground.viewFullScreen();return false;});QU.id("preview_image").addEventListener("load",Playground.onPreviewImageLoaded);
QU.id("crop_image").addEventListener("load",Playground.onCropImageLoaded);Playground._initStickyButtons(".controls button","active");
};QU.whenReady(Playground.init);